diff --git a/lib/hive/babysitter/events.rb b/lib/hive/babysitter/events.rb
index bc8e9977..7b8d10f4 100644
--- a/lib/hive/babysitter/events.rb
+++ b/lib/hive/babysitter/events.rb
@@ -53,8 +53,12 @@ module Hive
 
         path = File.join(project.fetch("hive_state_path"), "babysitter", "events.jsonl")
         FileUtils.mkdir_p(File.dirname(path))
+        line = "#{JSON.generate(record)}\n"
         File.open(path, File::WRONLY | File::APPEND | File::CREAT, 0o644, encoding: "UTF-8") do |file|
-          file.syswrite("#{JSON.generate(record)}\n")
+          written = file.syswrite(line)
+          unless written == line.bytesize
+            raise IOError, "short append to #{path}: wrote #{written} of #{line.bytesize} bytes"
+          end
         end
         record
       end
diff --git a/lib/hive/claude_completion_fallback.rb b/lib/hive/claude_completion_fallback.rb
new file mode 100644
index 00000000..59308cd7
--- /dev/null
+++ b/lib/hive/claude_completion_fallback.rb
@@ -0,0 +1,77 @@
+module Hive
+  # Generic, fail-closed policy for callers considering whether a missing
+  # Claude Stop signal may be suppressed. The launcher supplies runtime
+  # evidence; each phase adapter supplies its own authoritative facts.
+  # This layer deliberately performs no filesystem reads and emits no events.
+  module ClaudeCompletionFallback
+    Result = Data.define(:suppress, :missing_reasons)
+
+    REQUIRED_PHASE_FACTS = %i[
+      artifacts_present
+      artifacts_parseable
+      commit_or_no_change
+      no_unresolved_escalation
+      worktree_readable
+      no_missing_output
+    ].freeze
+
+    REQUIRED_TRUE_EVIDENCE = %i[
+      normal_completion
+      work_started
+      pane_idle
+      session_alive
+      tmux_readable
+    ].freeze
+
+    REQUIRED_FALSE_EVIDENCE = %i[
+      provider_limit
+      sentinel_present
+      result_present
+    ].freeze
+
+    module_function
+
+    def evaluate(evidence:, facts:)
+      normalized_evidence = normalize_keys(evidence)
+      normalized_facts = normalize_keys(facts)
+      missing = []
+
+      if normalized_evidence.empty?
+        missing << :completion_evidence
+      else
+        missing << :launch_mode unless normalized_evidence[:launch_mode].to_s == "tmux"
+        REQUIRED_TRUE_EVIDENCE.each do |field|
+          missing << field unless normalized_evidence[field] == true
+        end
+        REQUIRED_FALSE_EVIDENCE.each do |field|
+          missing << field unless normalized_evidence[field] == false
+        end
+        missing << :session_error unless blank?(normalized_evidence[:session_error])
+        missing << :process_state if normalized_evidence[:process_state].to_s == "dead"
+
+        exit_code = normalized_evidence[:exit_code]
+        missing << :exit_code unless exit_code.nil? || exit_code == 0
+      end
+
+      REQUIRED_PHASE_FACTS.each do |fact|
+        missing << :"phase_fact_#{fact}" unless normalized_facts[fact] == true
+      end
+
+      Result.new(suppress: missing.empty?, missing_reasons: missing.freeze)
+    end
+
+    def normalize_keys(value)
+      return {} unless value.is_a?(Hash)
+
+      value.each_with_object({}) do |(key, item), normalized|
+        normalized[key.to_sym] = item
+      rescue NoMethodError
+        normalized[key] = item
+      end
+    end
+
+    def blank?(value)
+      value.nil? || (value.respond_to?(:empty?) && value.empty?)
+    end
+  end
+end
diff --git a/lib/hive/claude_launcher.rb b/lib/hive/claude_launcher.rb
index b6820a41..4fba4d5e 100644
--- a/lib/hive/claude_launcher.rb
+++ b/lib/hive/claude_launcher.rb
@@ -16,6 +16,7 @@ module Hive
   module ClaudeLauncher
     READY_WAIT_TIMEOUT_SEC = 5
     DONE_POLL_INTERVAL_SEC = 0.5
+    STOP_SIGNAL_GRACE_SEC = 2.0
     SENTINEL_POLL_INTERVAL_SEC = 5
     SENTINEL_CAPTURE_BYTES = 8192
     PANE_LOG_CAPTURE_BYTES = 64 * 1024
@@ -275,7 +276,7 @@ module Hive
         Array(settings_paths).each do |path|
           safe_with_log(task, "cleanup_scratch") { cleanup_scratch(path) }
         end
-        safe_with_log(task, "cleanup_done") { cleanup_done(task) }
+        safe_with_log(task, "reset_signal_files") { reset_signal_files(task) }
       end
     end
 
@@ -843,6 +844,11 @@ module Hive
 
     def wait_for_done_signal(task, runner, timeout, log_label)
       deadline = Time.now + timeout
+      sentinel_path = done_path(task)
+      completion_result_path = result_path(task)
+      work_started = false
+      turn_settle_deadline = nil
+      result_settle_deadline = nil
       loop do
         # A usage/credit wall stalls claude WITHOUT ever touching `.done`,
         # so this exit_code_only path (the default `claude`/tmux execute
@@ -854,7 +860,8 @@ module Hive
         # detected wall as an :error carrying the limit error_message so the
         # execute stage stamps `reason="limits_reached"` and the cooldown
         # healer can hold/retry. `capture_limit_tail` is nil-runner safe.
-        pane_tail = capture_limit_tail(runner)
+        pane_probe = completion_pane_probe(runner)
+        pane_tail = pane_probe.fetch(:tail)
         if (limit_line = Hive::AgentLimit.live_limit_line(pane_tail))
           return {
             status: :error,
@@ -863,57 +870,258 @@ module Hive
           }
         end
 
-        if File.exist?(done_path(task))
+        sentinel_present = File.exist?(sentinel_path)
+        result_present =
+          !sentinel_present &&
+          result_settle_deadline.nil? &&
+          File.exist?(completion_result_path)
+        if sentinel_present
           # The stop-hook touches `.done` even on `empty_stdin` /
           # other non-success completions; the real status lives in
           # `result.json`. Without this check, an exit_code_only
           # caller (e.g. the Phase 4 fix agent) would see `:ok` for
           # an errored claude run.
-          status = read_result_json_status(task)
+          payload = read_result_json_payload(task)
+          unless payload
+            return {
+              status: :error,
+              error_message: "claude result.json missing or malformed after stop hook signal"
+            }
+          end
+
+          status = result_json_status(payload)
           if status == :ok
             return { status: :ok, log_label: log_label }
           elsif status
             return { status: status, log_label: log_label,
                      error_message: "claude reported #{status.inspect} via result.json" }
           end
-          # No result.json on disk yet — the .done write may have
-          # raced the result write. Treat as completion since
-          # exit_code_only callers don't carry a richer contract.
+          # A valid Stop-hook payload does not necessarily carry a
+          # status key. Its presence still proves the hook completed;
+          # explicit non-success statuses above remain failures.
           return { status: :ok, log_label: log_label }
         end
+        result_settle_deadline ||= Time.now + stop_signal_grace if result_present
+
+        session_probe = completion_session_probe(runner)
+        pane_idle = pane_probe[:readable] ? claude_ready_prompt?(pane_tail) : nil
+        work_started ||= pane_probe[:readable] && pane_idle == false
+
+        if session_probe[:alive] == false
+          return completion_timeout_result(
+            task, runner,
+            reason: :session_terminated,
+            work_started: work_started,
+            pane_idle: pane_idle,
+            pane_probe: pane_probe,
+            session_probe: session_probe
+          )
+        end
 
-        if Time.now >= deadline
-          return { status: :timeout, error_message: "claude stop hook did not signal completion" }
+        if session_probe[:error]
+          return completion_timeout_result(
+            task, runner,
+            reason: :session_unreadable,
+            work_started: work_started,
+            pane_idle: pane_idle,
+            pane_probe: pane_probe,
+            session_probe: session_probe
+          )
         end
 
-        sleep [ poll_interval, deadline - Time.now ].min
+        # A persistent Claude REPL has no truthful per-turn exit code.
+        # The conservative turn boundary is a readable non-idle pane
+        # followed by the validated idle prompt in the same live
+        # session. A Stop hook can arrive just after Claude paints the
+        # idle prompt, and result.json is intentionally written before
+        # `.done`; keep polling through one bounded settling window so
+        # teardown cannot discard a late explicit error or strand the
+        # required result-before-sentinel ordering. Keep
+        # status=:timeout; phase adapters decide whether their own
+        # artifacts make missing-signal evidence sufficient.
+        if work_started && pane_idle
+          turn_settle_deadline ||= Time.now + stop_signal_grace
+        end
+
+        now = Time.now
+        settle_deadline = [ turn_settle_deadline, result_settle_deadline ].compact.max
+        reason =
+          if turn_settle_deadline && settle_deadline && now >= settle_deadline
+            :busy_to_idle
+          elsif now >= deadline && (!result_settle_deadline || now >= result_settle_deadline)
+            pane_probe[:error] ? :pane_unreadable : :deadline
+          end
+
+        if reason
+          # Close the last result-before-sentinel race: either file may
+          # become visible after the loop's primary probe but before
+          # evidence finalization. A late sentinel gets the normal result
+          # parser on the next iteration; a newly visible result earns its
+          # own bounded wait for `.done`.
+          next if File.exist?(sentinel_path)
+
+          if result_settle_deadline.nil? && File.exist?(completion_result_path)
+            result_settle_deadline = Time.now + stop_signal_grace
+            next
+          end
+          result_remaining = result_settle_deadline && result_settle_deadline - Time.now
+          if result_remaining&.positive?
+            sleep [ poll_interval, result_remaining ].min
+            next
+          end
+
+          return completion_timeout_result(
+            task, runner,
+            reason: reason,
+            work_started: work_started,
+            pane_idle: pane_idle,
+            pane_probe: pane_probe,
+            session_probe: session_probe
+          )
+        end
+
+        next_deadline =
+          if turn_settle_deadline
+            settle_deadline
+          elsif result_settle_deadline && now >= deadline
+            result_settle_deadline
+          else
+            deadline
+          end
+        remaining = next_deadline - Time.now
+        next unless remaining.positive?
+
+        sleep [ poll_interval, remaining ].min
       end
     end
 
+    def completion_pane_probe(runner)
+      unless runner.respond_to?(:capture_pane_tail)
+        return { tail: "", readable: false, error: nil }
+      end
+
+      {
+        tail: runner.capture_pane_tail(bytes: SENTINEL_CAPTURE_BYTES).to_s,
+        readable: true,
+        error: nil
+      }
+    rescue Hive::TmuxError => e
+      { tail: "", readable: false, error: e.message }
+    end
+
+    def completion_session_probe(runner)
+      return { alive: nil, error: nil } unless runner.respond_to?(:session_exists?)
+
+      { alive: runner.session_exists?, error: nil }
+    rescue Hive::TmuxError => e
+      { alive: nil, error: e.message }
+    end
+
+    def completion_timeout_result(task, runner, reason:, work_started:, pane_idle:,
+                                  pane_probe:, session_probe:)
+      pid = recorded_claude_pid(task)
+      process_state = claude_process_state(pid)
+      sentinel_present = File.exist?(done_path(task))
+      result_present = File.exist?(result_path(task))
+      normal_completion =
+        reason == :busy_to_idle &&
+        work_started == true &&
+        pane_idle == true &&
+        pane_probe[:readable] == true &&
+        session_probe[:alive] == true &&
+        session_probe[:error].nil? &&
+        process_state != :dead &&
+        sentinel_present == false &&
+        result_present == false
+
+      {
+        status: :timeout,
+        error_message: "claude stop hook did not signal completion",
+        completion_evidence: {
+          reason: reason,
+          expected_signal_paths: {
+            sentinel: done_path(task),
+            result: result_path(task)
+          },
+          sentinel_present: sentinel_present,
+          result_present: result_present,
+          normal_completion: normal_completion,
+          launch_mode: :tmux,
+          work_started: work_started == true,
+          pane_idle: pane_idle,
+          session_alive: session_probe[:alive],
+          session_error: session_probe[:error] || pane_probe[:error],
+          tmux_readable: pane_probe[:readable] == true,
+          pid: pid,
+          process_state: process_state,
+          session_name: runner.respond_to?(:name) ? runner.name : nil,
+          provider_limit: false,
+          exit_code: nil
+        }
+      }
+    end
+
+    def recorded_claude_pid(task)
+      path = File.join(task.folder, ".lock")
+      return nil unless File.exist?(path)
+
+      data = YAML.safe_load(File.read(path))
+      pid = data["claude_pid"] if data.is_a?(Hash)
+      pid.is_a?(Integer) ? pid : nil
+    rescue Psych::Exception, SystemCallError, IOError
+      nil
+    end
+
+    def claude_process_state(pid)
+      return :unknown unless pid
+
+      Process.kill(0, pid)
+      :alive
+    rescue Errno::ESRCH
+      :dead
+    rescue Errno::EPERM
+      :alive
+    end
+
     # Read `result.json` (if present) and translate `status` into the
     # caller's symbol vocabulary. Unknown / unparseable shapes return
     # nil so the caller can fall through to its default success path.
     def read_result_json_status(task)
+      payload = read_result_json_payload(task)
+      return nil unless payload
+
+      result_json_status(payload)
+    end
+
+    def read_result_json_payload(task)
       path = result_path(task)
       return nil unless File.exist?(path) && File.size(path).positive?
 
       data = JSON.parse(File.read(path))
-      return nil unless data.is_a?(Hash)
+      data if data.is_a?(Hash)
+    rescue JSON::ParserError, SystemCallError, IOError
+      nil
+    end
 
-      raw = data["status"].to_s
+    def result_json_status(payload)
+      return :error if payload["hive_stop_hook"].to_s == "empty_stdin"
+
+      raw = payload["status"].to_s
       case raw
       when "ok", "complete", "success" then :ok
       when "" then nil
       else raw.to_sym
       end
-    rescue JSON::ParserError, SystemCallError, IOError
-      nil
     end
 
     def poll_interval
       Float(tmux_env("POLL_INTERVAL_SEC", DONE_POLL_INTERVAL_SEC.to_s))
     end
 
+    def stop_signal_grace
+      Float(tmux_env("STOP_SIGNAL_GRACE_SEC", STOP_SIGNAL_GRACE_SEC.to_s))
+    end
+
     def sentinel_poll_interval
       Float(tmux_env("SENTINEL_INTERVAL_SEC", SENTINEL_POLL_INTERVAL_SEC.to_s))
     end
diff --git a/lib/hive/events.rb b/lib/hive/events.rb
index 31ecc07a..bc3cc9b7 100644
--- a/lib/hive/events.rb
+++ b/lib/hive/events.rb
@@ -14,6 +14,7 @@ module Hive
       round_waiting
       round_complete
       clean_exit_auto_committed
+      claude_completion_fallback
     ].freeze
 
     STATUS_TAIL_LINES = 20
@@ -67,11 +68,14 @@ module Hive
       # writes would void the single-syscall atomicity assumption above.
       line = "#{JSON.generate(record)}\n"
       File.open(events_path, File::WRONLY | File::APPEND | File::CREAT, 0o644, encoding: "UTF-8") do |file|
-        file.syswrite(line)
+        written = file.syswrite(line)
+        unless written == line.bytesize
+          raise IOError, "short append to #{events_path}: wrote #{written} of #{line.bytesize} bytes"
+        end
       end
       render_status!(task_folder, record)
       record
-    rescue SystemCallError => e
+    rescue SystemCallError, IOError => e
       warn "[hive.events] failed to emit #{event_type} for #{task_folder}: #{e.class}: #{e.message}"
       nil
     end
